implement MultiarchCross for build-dep and source (Closes: #632221)
[ntk/apt.git] / test / integration / framework
CommitLineData
8d876415
DK
1#!/bin/sh -- # no runable script, just for vi
2
3# we all like colorful messages
4CERROR="\e[1;31m" # red
5CWARNING="\e[1;33m" # yellow
6CMSG="\e[1;32m" # green
7CINFO="\e[1;96m" # light blue
8CDEBUG="\e[1;94m" # blue
9CNORMAL="\e[0;39m" # default system console color
10CDONE="\e[1;32m" # green
11CPASS="\e[1;32m" # green
12CFAIL="\e[1;31m" # red
13CCMD="\e[1;35m" # pink
14
15msgdie() { echo "${CERROR}E: $1${CNORMAL}" >&2; exit 1; }
16msgwarn() { echo "${CWARNING}W: $1${CNORMAL}" >&2; }
17msgmsg() { echo "${CMSG}$1${CNORMAL}" >&2; }
18msginfo() { echo "${CINFO}I: $1${CNORMAL}" >&2; }
19msgdebug() { echo "${CDEBUG}D: $1${CNORMAL}" >&2; }
20msgdone() { echo "${CDONE}DONE${CNORMAL}" >&2; }
21msgnwarn() { echo -n "${CWARNING}W: $1${CNORMAL}" >&2; }
22msgnmsg() { echo -n "${CMSG}$1${CNORMAL}" >&2; }
23msgninfo() { echo -n "${CINFO}I: $1${CNORMAL}" >&2; }
24msgndebug() { echo -n "${CDEBUG}D: $1${CNORMAL}" >&2; }
25msgtest() { echo -n "${CINFO}$1 ${CCMD}$(echo "$2" | sed -e 's/^aptc/apt-c/' -e 's/^aptg/apt-g/' -e 's/^aptf/apt-f/')${CINFO} …${CNORMAL} " >&2; }
26msgpass() { echo "${CPASS}PASS${CNORMAL}" >&2; }
27msgskip() { echo "${CWARNING}SKIP${CNORMAL}" >&2; }
28msgfail() { echo "${CFAIL}FAIL${CNORMAL}" >&2; }
29
30# enable / disable Debugging
fc89263e
DK
31MSGLEVEL=${MSGLEVEL:-3}
32if [ $MSGLEVEL -le 0 ]; then
33 msgdie() { true; }
34fi
35if [ $MSGLEVEL -le 1 ]; then
36 msgwarn() { true; }
37 msgnwarn() { true; }
38fi
39if [ $MSGLEVEL -le 2 ]; then
40 msgmsg() { true; }
41 msgnmsg() { true; }
39cc8228
DK
42 msgtest() { true; }
43 msgpass() { echo -n " ${CPASS}P${CNORMAL}" >&2; }
44 msgskip() { echo -n " ${CWARNING}S${CNORMAL}" >&2; }
45 msgfail() { echo -n " ${CFAIL}FAIL${CNORMAL}" >&2; }
fc89263e
DK
46fi
47if [ $MSGLEVEL -le 3 ]; then
48 msginfo() { true; }
49 msgninfo() { true; }
50fi
51if [ $MSGLEVEL -le 4 ]; then
52 msgdebug() { true; }
53 msgndebug() { true; }
54fi
55msgdone() {
56 if [ "$1" = "debug" -a $MSGLEVEL -le 4 ] ||
57 [ "$1" = "info" -a $MSGLEVEL -le 3 ] ||
58 [ "$1" = "msg" -a $MSGLEVEL -le 2 ] ||
59 [ "$1" = "warn" -a $MSGLEVEL -le 1 ] ||
60 [ "$1" = "die" -a $MSGLEVEL -le 0 ]; then
61 true;
62 else
63 echo "${CDONE}DONE${CNORMAL}" >&2;
64 fi
65}
8d876415
DK
66
67runapt() {
68 msgdebug "Executing: ${CCMD}$*${CDEBUG} "
7d0627b6
DK
69 if [ -f ./aptconfig.conf ]; then
70 APT_CONFIG=aptconfig.conf LD_LIBRARY_PATH=${BUILDDIRECTORY} ${BUILDDIRECTORY}/$*
4b2a4ab8
MV
71 elif [ -f ../aptconfig.conf ]; then
72 APT_CONFIG=../aptconfig.conf LD_LIBRARY_PATH=${BUILDDIRECTORY} ${BUILDDIRECTORY}/$*
7d0627b6
DK
73 else
74 LD_LIBRARY_PATH=${BUILDDIRECTORY} ${BUILDDIRECTORY}/$*
75 fi
8d876415
DK
76}
77aptconfig() { runapt apt-config $*; }
78aptcache() { runapt apt-cache $*; }
79aptget() { runapt apt-get $*; }
80aptftparchive() { runapt apt-ftparchive $*; }
1f8b2599 81aptkey() { runapt apt-key $*; }
ec7f904e 82aptmark() { runapt apt-mark $*; }
158fda31
DK
83dpkg() {
84 $(which dpkg) --root=${TMPWORKINGDIRECTORY}/rootdir --force-not-root --force-bad-path --log=${TMPWORKINGDIRECTORY}/rootdir/var/log/dpkg.log $*
85}
b6b5a542
DK
86aptitude() {
87 if [ -f ./aptconfig.conf ]; then
88 APT_CONFIG=aptconfig.conf LD_LIBRARY_PATH=${BUILDDIRECTORY} $(which aptitude) $*
89 elif [ -f ../aptconfig.conf ]; then
90 APT_CONFIG=../aptconfig.conf LD_LIBRARY_PATH=${BUILDDIRECTORY} $(which aptitude) $*
91 else
92 LD_LIBRARY_PATH=${BUILDDIRECTORY} $(which aptitude) $*
93 fi
94}
8d876415 95
b720d0bd
DK
96addtrap() {
97 CURRENTTRAP="$CURRENTTRAP $1"
98 trap "$CURRENTTRAP" 0 HUP INT QUIT ILL ABRT FPE SEGV PIPE TERM
99}
8d876415
DK
100
101setupenvironment() {
75954ae2 102 TMPWORKINGDIRECTORY=$(mktemp -d)
8f8169ac 103 local TESTDIR=$(readlink -f $(dirname $0))
3cbbda3c 104 msgninfo "Preparing environment for ${CCMD}$(basename $0)${CINFO} in ${TMPWORKINGDIRECTORY}… "
8f8169ac 105 BUILDDIRECTORY="${TESTDIR}/../../build/bin"
8d876415
DK
106 test -x "${BUILDDIRECTORY}/apt-get" || msgdie "You need to build tree first"
107 local OLDWORKINGDIRECTORY=$(pwd)
b720d0bd 108 addtrap "cd /; rm -rf $TMPWORKINGDIRECTORY; cd $OLDWORKINGDIRECTORY;"
8d876415 109 cd $TMPWORKINGDIRECTORY
cd725954 110 mkdir rootdir aptarchive keys
8d876415 111 cd rootdir
b29c3712
DK
112 mkdir -p etc/apt/apt.conf.d etc/apt/sources.list.d etc/apt/trusted.gpg.d etc/apt/preferences.d
113 mkdir -p var/cache var/lib var/log
cffea9af 114 mkdir -p var/lib/dpkg/info var/lib/dpkg/updates var/lib/dpkg/triggers
2c6baa5a 115 local STATUSFILE=$(echo "$(basename $0)" | sed -e 's/^test-/status-/' -e 's/^skip-/status-/')
8f8169ac
DK
116 if [ -f "${TESTDIR}/${STATUSFILE}" ]; then
117 cp "${TESTDIR}/${STATUSFILE}" var/lib/dpkg/status
118 else
119 touch var/lib/dpkg/status
120 fi
cd725954 121 touch var/lib/dpkg/available
8d876415
DK
122 mkdir -p usr/lib/apt
123 ln -s ${BUILDDIRECTORY}/methods usr/lib/apt/methods
124 cd ..
2c6baa5a 125 local PACKAGESFILE=$(echo "$(basename $0)" | sed -e 's/^test-/Packages-/' -e 's/^skip-/Packages-/')
8f8169ac
DK
126 if [ -f "${TESTDIR}/${PACKAGESFILE}" ]; then
127 cp "${TESTDIR}/${PACKAGESFILE}" aptarchive/Packages
8f8169ac 128 fi
4a4ea26c
AM
129 local SOURCESSFILE=$(echo "$(basename $0)" | sed -e 's/^test-/Sources-/' -e 's/^skip-/Sources-/')
130 if [ -f "${TESTDIR}/${SOURCESSFILE}" ]; then
131 cp "${TESTDIR}/${SOURCESSFILE}" aptarchive/Sources
8f8169ac 132 fi
cd725954
DK
133 cp $(find $TESTDIR -name '*.pub' -o -name '*.sec') keys/
134 ln -s ${TMPWORKINGDIRECTORY}/keys/joesixpack.pub rootdir/etc/apt/trusted.gpg.d/joesixpack.gpg
cffea9af 135 echo "Dir \"${TMPWORKINGDIRECTORY}/rootdir\";" > aptconfig.conf
94eb3bee 136 echo "Dir::state::status \"${TMPWORKINGDIRECTORY}/rootdir/var/lib/dpkg/status\";" >> aptconfig.conf
8d876415
DK
137 echo "Debug::NoLocking \"true\";" >> aptconfig.conf
138 echo "APT::Get::Show-User-Simulation-Note \"false\";" >> aptconfig.conf
f425d4d5 139 echo "Dir::Bin::Methods \"${BUILDDIRECTORY}/methods\";" >> aptconfig.conf
cffea9af
DK
140 echo "Dir::Bin::dpkg \"fakeroot\";" >> aptconfig.conf
141 echo "DPKG::options:: \"dpkg\";" >> aptconfig.conf
142 echo "DPKG::options:: \"--root=${TMPWORKINGDIRECTORY}/rootdir\";" >> aptconfig.conf
143 echo "DPKG::options:: \"--force-not-root\";" >> aptconfig.conf
144 echo "DPKG::options:: \"--force-bad-path\";" >> aptconfig.conf
145 echo "DPKG::options:: \"--log=${TMPWORKINGDIRECTORY}/rootdir/var/log/dpkg.log\";" >> aptconfig.conf
2c085486 146 echo 'quiet::NoUpdate "true";' >> aptconfig.conf
8d876415 147 export LC_ALL=C
7f52cf7b 148 export PATH="${PATH}:/usr/local/sbin:/usr/sbin:/sbin"
8d876415
DK
149 msgdone "info"
150}
151
152configarchitecture() {
153 local CONFFILE=rootdir/etc/apt/apt.conf.d/01multiarch.conf
234675b7 154 rm -f $CONFFILE
8d876415
DK
155 echo "APT::Architecture \"$1\";" > $CONFFILE
156 shift
157 while [ -n "$1" ]; do
158 echo "APT::Architectures:: \"$1\";" >> $CONFFILE
159 shift
160 done
161}
162
75954ae2 163setupsimplenativepackage() {
ce9864a8
DK
164 local NAME="$1"
165 local ARCH="$2"
166 local VERSION="$3"
167 local RELEASE="${4:-unstable}"
168 local DEPENDENCIES="$5"
169 local DESCRIPTION="$6"
b7899b00
DK
170 local SECTION="${7:-others}"
171 local DISTSECTION
172 if [ "$SECTION" = "$(echo "$SECTION" | cut -d'/' -f 2)" ]; then
173 DISTSECTION="main"
174 else
175 DISTSECTION="$(echo "$SECTION" | cut -d'/' -f 1)"
176 fi
ce9864a8
DK
177 local BUILDDIR=incoming/${NAME}-${VERSION}
178 mkdir -p ${BUILDDIR}/debian/source
179 cd ${BUILDDIR}
180 echo "* most suckless software product ever" > FEATURES
b7899b00
DK
181 test -e debian/copyright || echo "Copyleft by Joe Sixpack $(date +%Y)" > debian/copyright
182 test -e debian/changelog || echo "$NAME ($VERSION) $RELEASE; urgency=low
ce9864a8
DK
183
184 * Initial release
185
b7899b00
DK
186 -- Joe Sixpack <joe@example.org> $(date -R)" > debian/changelog
187 test -e debian/control || echo "Source: $NAME
188Section: $SECTION
ce9864a8
DK
189Priority: optional
190Maintainer: Joe Sixpack <joe@example.org>
191Build-Depends: debhelper (>= 7)
192Standards-Version: 3.9.1
193
875bcb36
DK
194Package: $NAME" > debian/control
195 if [ "$ARCH" = 'all' ]; then
196 echo "Architecture: all" >> debian/control
197 else
198 echo "Architecture: any" >> debian/control
199 fi
ce9864a8
DK
200 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> debian/control
201 if [ -z "$DESCRIPTION" ]; then
202 echo "Description: an autogenerated dummy ${NAME}=${VERSION}/${RELEASE}
203 If you find such a package installed on your system,
204 YOU did something horribly wrong! They are autogenerated
205 und used only by testcases for APT and surf no other propose…" >> debian/control
206 else
207 echo "Description: $DESCRIPTION" >> debian/control
208 fi
b7899b00
DK
209 test -e debian/compat || echo "7" > debian/compat
210 test -e debian/source/format || echo "3.0 (native)" > debian/source/format
ce9864a8 211 test -e debian/rules || cp /usr/share/doc/debhelper/examples/rules.tiny debian/rules
75954ae2
DK
212 cd - > /dev/null
213}
214
215buildsimplenativepackage() {
216 local NAME="$1"
217 local ARCH="$2"
218 local VERSION="$3"
219 local RELEASE="${4:-unstable}"
220 local DEPENDENCIES="$5"
221 local DESCRIPTION="$6"
222 local SECTION="${7:-others}"
d67004e0 223 local PRIORITY="${8:-optional}"
75954ae2
DK
224 local DISTSECTION
225 if [ "$SECTION" = "$(echo "$SECTION" | cut -d'/' -f 2)" ]; then
226 DISTSECTION="main"
227 else
228 DISTSECTION="$(echo "$SECTION" | cut -d'/' -f 1)"
229 fi
5a635ee4 230 local BUILDDIR=${TMPWORKINGDIRECTORY}/incoming/${NAME}-${VERSION}
b761356f 231
18331adf 232 msgninfo "Build package ${NAME} in ${VERSION} for ${RELEASE} in ${DISTSECTION}… "
b761356f
DK
233 mkdir -p $BUILDDIR/debian/source
234 echo "* most suckless software product ever" > ${BUILDDIR}/FEATURES
235 echo "#!/bin/sh
236echo '$NAME says \"Hello!\"'" > ${BUILDDIR}/${NAME}
237
238 echo "Copyleft by Joe Sixpack $(date +%Y)" > ${BUILDDIR}/debian/copyright
239 echo "$NAME ($VERSION) $RELEASE; urgency=low
240
241 * Initial release
242
243 -- Joe Sixpack <joe@example.org> $(date -R)" > ${BUILDDIR}/debian/changelog
244 echo "Source: $NAME
245Section: $SECTION
d67004e0 246Priority: $PRIORITY
b761356f
DK
247Maintainer: Joe Sixpack <joe@example.org>
248Standards-Version: 3.9.1
249
875bcb36
DK
250Package: $NAME" > ${BUILDDIR}/debian/control
251 if [ "$ARCH" = 'all' ]; then
252 echo "Architecture: all" >> ${BUILDDIR}/debian/control
253 else
254 echo "Architecture: any" >> ${BUILDDIR}/debian/control
255 fi
b761356f
DK
256 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> ${BUILDDIR}/debian/control
257 if [ -z "$DESCRIPTION" ]; then
258 echo "Description: an autogenerated dummy ${NAME}=${VERSION}/${RELEASE}
259 If you find such a package installed on your system,
260 YOU did something horribly wrong! They are autogenerated
261 und used only by testcases for APT and surf no other propose…" >> ${BUILDDIR}/debian/control
262 else
263 echo "Description: $DESCRIPTION" >> ${BUILDIR}/debian/control
264 fi
265 echo '3.0 (native)' > ${BUILDDIR}/debian/source/format
266 local SRCS="$( (cd ${BUILDDIR}/..; dpkg-source -b ${NAME}-${VERSION} 2>&1) | grep '^dpkg-source: info: building' | grep -o '[a-z0-9._+~-]*$')"
b761356f 267 for SRC in $SRCS; do
5a635ee4 268 echo "pool/${SRC}" >> ${BUILDDIR}/../${RELEASE}.${DISTSECTION}.srclist
b761356f 269 done
84aa13f4
DK
270
271 for arch in $(echo "$ARCH" | sed -e 's#,#\n#g'); do
272 rm -rf ${BUILDDIR}/debian/tmp
273 mkdir -p ${BUILDDIR}/debian/tmp/DEBIAN ${BUILDDIR}/debian/tmp/usr/share/doc/${NAME} ${BUILDDIR}/debian/tmp/usr/bin
274 cp ${BUILDDIR}/debian/copyright ${BUILDDIR}/debian/changelog ${BUILDDIR}/FEATURES ${BUILDDIR}/debian/tmp/usr/share/doc/${NAME}
275 cp ${BUILDDIR}/${NAME} ${BUILDDIR}/debian/tmp/usr/bin/${NAME}-${arch}
276 (cd ${BUILDDIR}; dpkg-gencontrol -DArchitecture=$arch)
277 (cd ${BUILDDIR}/debian/tmp; md5sum $(find usr/ -type f) > DEBIAN/md5sums)
278
279 dpkg-deb --build ${BUILDDIR}/debian/tmp ${BUILDDIR}/.. 2> /dev/null > /dev/null
280 echo "pool/${NAME}_${VERSION}_${arch}.deb" >> ${BUILDDIR}/../${RELEASE}.${DISTSECTION}.pkglist
281 done
282
13845042
DK
283 mkdir -p ${BUILDDIR}/../${NAME}_${VERSION}
284 cp ${BUILDDIR}/debian/changelog ${BUILDDIR}/../${NAME}_${VERSION}/
285 cp ${BUILDDIR}/debian/changelog ${BUILDDIR}/../${NAME}_${VERSION}.changelog
5a635ee4 286 rm -rf "${BUILDDIR}"
b761356f 287 msgdone "info"
75954ae2
DK
288}
289
290buildpackage() {
291 local BUILDDIR=$1
292 local RELEASE=$2
293 local SECTION=$3
294 msgninfo "Build package $(echo "$BUILDDIR" | grep -o '[^/]*$') for ${RELEASE} in ${SECTION}… "
295 cd $BUILDDIR
296 if [ "$ARCH" = "all" ]; then
297 ARCH="$(dpkg-architecture -qDEB_HOST_ARCH 2> /dev/null)"
298 fi
b7899b00
DK
299 local BUILT="$(dpkg-buildpackage -uc -us -a$ARCH 2> /dev/null)"
300 local PKGS="$( echo "$BUILT" | grep '^dpkg-deb: building package' | cut -d'/' -f 2 | sed -e "s#'\.##")"
5ed56f93 301 local SRCS="$( echo "$BUILT" | grep '^dpkg-source: info: building' | grep -o '[a-z0-9._+~-]*$')"
ce9864a8 302 cd - > /dev/null
b7899b00 303 for PKG in $PKGS; do
75954ae2 304 echo "pool/${PKG}" >> ${TMPWORKINGDIRECTORY}/incoming/${RELEASE}.${SECTION}.pkglist
b7899b00
DK
305 done
306 for SRC in $SRCS; do
75954ae2 307 echo "pool/${SRC}" >> ${TMPWORKINGDIRECTORY}/incoming/${RELEASE}.${SECTION}.srclist
b7899b00 308 done
cffea9af 309 msgdone "info"
ce9864a8
DK
310}
311
312buildaptarchive() {
ce9864a8
DK
313 if [ -d incoming ]; then
314 buildaptarchivefromincoming $*
315 else
316 buildaptarchivefromfiles $*
317 fi
318}
319
320createaptftparchiveconfig() {
321 local ARCHS="$(find pool/ -name '*.deb' | grep -oE '_[a-z0-9-]+\.deb$' | sort | uniq | sed -e '/^_all.deb$/ d' -e 's#^_\([a-z0-9-]*\)\.deb$#\1#' | tr '\n' ' ')"
158fda31
DK
322 if [ -z "$ARCHS" ]; then
323 # the pool is empty, so we will operate on faked packages - let us use the configured archs
324 ARCHS="$(aptconfig dump | grep APT::Architecture | cut -d'"' -f 2 | sed '/^$/ d' | sort | uniq | tr '\n' ' ')"
325 fi
ce9864a8
DK
326 echo -n 'Dir {
327 ArchiveDir "' >> ftparchive.conf
328 echo -n $(readlink -f .) >> ftparchive.conf
329 echo -n '";
330 CacheDir "' >> ftparchive.conf
331 echo -n $(readlink -f ..) >> ftparchive.conf
332 echo -n '";
b7899b00
DK
333 FileListDir "' >> ftparchive.conf
334 echo -n $(readlink -f pool/) >> ftparchive.conf
335 echo -n '";
336};
337Default {
bc33e0f0
DK
338 Packages::Compress ". gzip bzip2 lzma xz";
339 Sources::Compress ". gzip bzip2 lzma xz";
340 Contents::Compress ". gzip bzip2 lzma xz";
b7080ced 341 Translation::Compress ". gzip bzip2 lzma xz";
18331adf 342 LongDescription "false";
ce9864a8
DK
343};
344TreeDefault {
345 Directory "pool/";
346 SrcDirectory "pool/";
347};
348APT {
349 FTPArchive {
350 Release {
351 Origin "joesixpack";
352 Label "apttestcases";
353 Suite "unstable";
354 Description "repository with dummy packages";
355 Architectures "' >> ftparchive.conf
356 echo -n "$ARCHS" >> ftparchive.conf
357 echo 'source";
358 };
359 };
360};' >> ftparchive.conf
b7899b00
DK
361 for DIST in $(find ./pool/ -maxdepth 1 -name '*.pkglist' -type f | cut -d'/' -f 3 | cut -d'.' -f 1 | sort | uniq); do
362 echo -n 'tree "dists/' >> ftparchive.conf
363 echo -n "$DIST" >> ftparchive.conf
364 echo -n '" {
ce9864a8
DK
365 Architectures "' >> ftparchive.conf
366 echo -n "$ARCHS" >> ftparchive.conf
b7899b00
DK
367 echo -n 'source";
368 FileList "' >> ftparchive.conf
369 echo -n "${DIST}.\$(SECTION).pkglist" >> ftparchive.conf
370 echo -n '";
371 SourceFileList "' >> ftparchive.conf
372 echo -n "${DIST}.\$(SECTION).srclist" >> ftparchive.conf
373 echo -n '";
374 Sections "' >> ftparchive.conf
375 echo -n "$(find ./pool/ -maxdepth 1 -name "${DIST}.*.pkglist" -type f | cut -d'/' -f 3 | cut -d'.' -f 2 | sort | uniq | tr '\n' ' ')" >> ftparchive.conf
376 echo '";
ce9864a8 377};' >> ftparchive.conf
b7899b00 378 done
ce9864a8
DK
379}
380
381buildaptftparchivedirectorystructure() {
b7899b00
DK
382 local DISTS="$(grep -i '^tree ' ftparchive.conf | cut -d'/' -f 2 | sed -e 's#".*##')"
383 for DIST in $DISTS; do
384 local SECTIONS="$(grep -i -A 5 "dists/$DIST" ftparchive.conf | grep -i 'Sections' | cut -d'"' -f 2)"
385 for SECTION in $SECTIONS; do
386 local ARCHS="$(grep -A 5 "dists/$DIST" ftparchive.conf | grep Architectures | cut -d'"' -f 2 | sed -e 's#source##')"
387 for ARCH in $ARCHS; do
388 mkdir -p dists/${DIST}/${SECTION}/binary-${ARCH}
389 done
390 mkdir -p dists/${DIST}/${SECTION}/source
391 mkdir -p dists/${DIST}/${SECTION}/i18n
392 done
ce9864a8 393 done
ce9864a8
DK
394}
395
9b78cda6
DK
396insertpackage() {
397 local RELEASE="$1"
398 local NAME="$2"
399 local ARCH="$3"
400 local VERSION="$4"
401 local DEPENDENCIES="$5"
d67004e0
DK
402 local PRIORITY="${6:-optional}"
403 local ARCHS=""
404 for arch in $(echo "$ARCH" | sed -e 's#,#\n#g'); do
405 if [ "$arch" = "all" ]; then
406 ARCHS="$(aptconfig dump | grep APT::Architecture | cut -d'"' -f 2 | sed '/^$/ d' | sort | uniq | tr '\n' ' ')"
407 else
408 ARCHS="$arch"
409 fi
410 for BUILDARCH in $ARCHS; do
411 local PPATH="aptarchive/dists/${RELEASE}/main/binary-${BUILDARCH}"
412 mkdir -p $PPATH aptarchive/dists/${RELEASE}/main/source
413 touch aptarchive/dists/${RELEASE}/main/source/Sources
414 local FILE="${PPATH}/Packages"
415 echo "Package: $NAME
416Priority: $PRIORITY
9b78cda6 417Section: other
2c085486 418Installed-Size: 42
9b78cda6 419Maintainer: Joe Sixpack <joe@example.org>
d67004e0 420Architecture: $arch
2c085486 421Version: $VERSION
d67004e0
DK
422Filename: pool/main/${NAME}/${NAME}_${VERSION}_${arch}.deb" >> $FILE
423 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> $FILE
424 echo "Description: an autogenerated dummy ${NAME}=${VERSION}/${RELEASE}
9b78cda6
DK
425 If you find such a package installed on your system,
426 YOU did something horribly wrong! They are autogenerated
427 und used only by testcases for APT and surf no other propose…
428" >> $FILE
d67004e0 429 done
9b78cda6
DK
430 done
431}
432
234675b7
DK
433insertsource() {
434 local RELEASE="$1"
435 local NAME="$2"
436 local ARCH="$3"
437 local VERSION="$4"
438 local DEPENDENCIES="$5"
439 local ARCHS=""
440 local SPATH="aptarchive/dists/${RELEASE}/main/source"
441 mkdir -p $SPATH
442 local FILE="${SPATH}/Sources"
443 echo "Package: $NAME
444Binary: $NAME
445Version: $VERSION
446Maintainer: Joe Sixpack <joe@example.org>
447Architecture: $ARCH" >> $FILE
448 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> $FILE
449 echo "Files:
450 d41d8cd98f00b204e9800998ecf8427e 0 ${NAME}_${VERSION}.dsc
451 d41d8cd98f00b204e9800998ecf8427e 0 ${NAME}_${VERSION}.tar.gz" >> $FILE
452}
453
dfc2b1be
DK
454insertinstalledpackage() {
455 local NAME="$1"
456 local ARCH="$2"
457 local VERSION="$3"
458 local DEPENDENCIES="$4"
d67004e0 459 local PRIORITY="${5:-optional}"
dfc2b1be 460 local FILE="rootdir/var/lib/dpkg/status"
d67004e0
DK
461 for arch in $(echo "$ARCH" | sed -e 's#,#\n#g'); do
462 echo "Package: $NAME
dfc2b1be 463Status: install ok installed
d67004e0 464Priority: $PRIORITY
dfc2b1be
DK
465Section: other
466Installed-Size: 42
467Maintainer: Joe Sixpack <joe@example.org>
d67004e0 468Architecture: $arch
dfc2b1be 469Version: $VERSION" >> $FILE
d67004e0
DK
470 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> $FILE
471 echo "Description: an autogenerated dummy ${NAME}=${VERSION}/installed
dfc2b1be
DK
472 If you find such a package installed on your system,
473 YOU did something horribly wrong! They are autogenerated
474 und used only by testcases for APT and surf no other propose…
475" >> $FILE
d67004e0 476 done
dfc2b1be
DK
477}
478
479
ce9864a8 480buildaptarchivefromincoming() {
3cbbda3c 481 msginfo "Build APT archive for ${CCMD}$(basename $0)${CINFO} based on incoming packages…"
ce9864a8
DK
482 cd aptarchive
483 [ -e pool ] || ln -s ../incoming pool
484 [ -e ftparchive.conf ] || createaptftparchiveconfig
485 [ -e dists ] || buildaptftparchivedirectorystructure
b7899b00 486 msgninfo "\tGenerate Packages, Sources and Contents files… "
ce9864a8 487 aptftparchive -qq generate ftparchive.conf
ce9864a8
DK
488 cd - > /dev/null
489 msgdone "info"
9b78cda6 490 generatereleasefiles
ce9864a8
DK
491}
492
493buildaptarchivefromfiles() {
3cbbda3c 494 msginfo "Build APT archive for ${CCMD}$(basename $0)${CINFO} based on prebuild files…"
9b78cda6
DK
495 find aptarchive -name 'Packages' -o -name 'Sources' | while read line; do
496 msgninfo "\t${line} file… "
497 cat ${line} | gzip > ${line}.gz
498 cat ${line} | bzip2 > ${line}.bz2
499 cat ${line} | lzma > ${line}.lzma
b7080ced 500 cat ${line} | xz > ${line}.xz
8d876415 501 msgdone "info"
9b78cda6
DK
502 done
503 generatereleasefiles
504}
505
a3bbbab7
DK
506# can be overridden by testcases for their pleasure
507getcodenamefromsuite() { echo -n "$1"; }
508getreleaseversionfromsuite() { true; }
509
9b78cda6
DK
510generatereleasefiles() {
511 msgninfo "\tGenerate Release files… "
fe0f7911 512 local DATE="${1:-now}"
9b78cda6 513 if [ -e aptarchive/dists ]; then
18331adf
DK
514 for dir in $(find ./aptarchive/dists -mindepth 3 -maxdepth 3 -type d -name 'i18n'); do
515 aptftparchive -qq release $dir -o APT::FTPArchive::Release::Patterns::='Translation-*' > $dir/Index
516 done
9b78cda6 517 for dir in $(find ./aptarchive/dists -mindepth 1 -maxdepth 1 -type d); do
a3bbbab7
DK
518 local SUITE="$(echo "$dir" | cut -d'/' -f 4)"
519 local CODENAME="$(getcodenamefromsuite $SUITE)"
520 local VERSION="$(getreleaseversionfromsuite $SUITE)"
521 if [ -z "$VERSION" ]; then
522 aptftparchive -qq release $dir \
523 -o APT::FTPArchive::Release::Suite="${SUITE}" \
524 -o APT::FTPArchive::Release::Codename="${CODENAME}" \
525 | sed -e '/0 Release$/ d' > $dir/Release # remove the self reference
526 else
527 aptftparchive -qq release $dir \
528 -o APT::FTPArchive::Release::Suite="${SUITE}" \
529 -o APT::FTPArchive::Release::Codename="${CODENAME}" \
530 -o APT::FTPArchive::Release::Version="${VERSION}" \
531 | sed -e '/0 Release$/ d' > $dir/Release # remove the self reference
532 fi
533 if [ "$SUITE" = "experimental" -o "$SUITE" = "experimental2" ]; then
35faae11
DK
534 sed -i '/^Date: / a\
535NotAutomatic: yes' $dir/Release
536 fi
9b78cda6
DK
537 done
538 else
539 aptftparchive -qq release ./aptarchive | sed -e '/0 Release$/ d' > aptarchive/Release # remove the self reference
8d876415 540 fi
fe0f7911
DK
541 if [ "$DATE" != "now" ]; then
542 for release in $(find ./aptarchive -name 'Release'); do
543 touch -d "$1" $release
544 done
8d876415 545 fi
b7899b00 546 msgdone "info"
8d876415
DK
547}
548
b7899b00
DK
549setupdistsaptarchive() {
550 local APTARCHIVE=$(readlink -f ./aptarchive)
551 rm -f root/etc/apt/sources.list.d/apt-test-*-deb.list
552 rm -f root/etc/apt/sources.list.d/apt-test-*-deb-src.list
553 for DISTS in $(find ./aptarchive/dists/ -mindepth 1 -maxdepth 1 -type d | cut -d'/' -f 4); do
554 SECTIONS=$(find ./aptarchive/dists/${DISTS}/ -mindepth 1 -maxdepth 1 -type d | cut -d'/' -f 5 | tr '\n' ' ')
555 msgninfo "\tadd deb and deb-src sources.list lines for ${CCMD}${DISTS} ${SECTIONS}${CINFO}… "
556 echo "deb file://$APTARCHIVE $DISTS $SECTIONS" > rootdir/etc/apt/sources.list.d/apt-test-${DISTS}-deb.list
557 echo "deb-src file://$APTARCHIVE $DISTS $SECTIONS" > rootdir/etc/apt/sources.list.d/apt-test-${DISTS}-deb-src.list
558 msgdone "info"
559 done
560}
561
562setupflataptarchive() {
ce9864a8 563 local APTARCHIVE=$(readlink -f ./aptarchive)
8d876415
DK
564 if [ -f ${APTARCHIVE}/Packages ]; then
565 msgninfo "\tadd deb sources.list line… "
566 echo "deb file://$APTARCHIVE /" > rootdir/etc/apt/sources.list.d/apt-test-archive-deb.list
567 msgdone "info"
568 else
569 rm -f rootdir/etc/apt/sources.list.d/apt-test-archive-deb.list
570 fi
571 if [ -f ${APTARCHIVE}/Sources ]; then
572 msgninfo "\tadd deb-src sources.list line… "
573 echo "deb-src file://$APTARCHIVE /" > rootdir/etc/apt/sources.list.d/apt-test-archive-deb-src.list
574 msgdone "info"
575 else
576 rm -f rootdir/etc/apt/sources.list.d/apt-test-archive-deb-src.list
577 fi
b7899b00
DK
578}
579
580setupaptarchive() {
581 buildaptarchive
582 if [ -e aptarchive/dists ]; then
583 setupdistsaptarchive
584 else
585 setupflataptarchive
586 fi
f213b6ea 587 signreleasefiles
cd725954 588 msgninfo "\tSync APT's cache with the archive… "
8d876415 589 aptget update -qq
cd725954 590 msgdone "info"
8d876415
DK
591}
592
f213b6ea
DK
593signreleasefiles() {
594 local SIGNER="${1:-Joe Sixpack}"
595 msgninfo "\tSign archive with $SIGNER key… "
596 local SECKEYS=""
597 for KEY in $(find keys/ -name '*.sec'); do
598 SECKEYS="$SECKEYS --secret-keyring $KEY"
599 done
600 local PUBKEYS=""
601 for KEY in $(find keys/ -name '*.pub'); do
602 PUBKEYS="$PUBKEYS --keyring $KEY"
603 done
604 for RELEASE in $(find aptarchive/ -name Release); do
605 gpg --yes --no-default-keyring $SECKEYS $PUBKEYS --default-key "$SIGNER" -abs -o ${RELEASE}.gpg ${RELEASE}
fe0f7911 606 gpg --yes --no-default-keyring $SECKEYS $PUBKEYS --default-key "$SIGNER" --clearsign -o "$(echo "${RELEASE}" | sed 's#/Release$#/InRelease#')" $RELEASE
f213b6ea
DK
607 done
608 msgdone "info"
609}
610
611changetowebserver() {
612 if which weborf > /dev/null; then
613 weborf -xb aptarchive/ 2>&1 > /dev/null &
b720d0bd 614 addtrap "kill $!;"
c5bcc607
DK
615 elif which lighttpd > /dev/null; then
616 echo "server.document-root = \"$(readlink -f ./aptarchive)\"
617server.port = 8080
618server.stat-cache-engine = \"disable\"" > lighttpd.conf
619 lighttpd -t -f lighttpd.conf >/dev/null || msgdie 'Can not change to webserver: our lighttpd config is invalid'
620 lighttpd -D -f lighttpd.conf 2>/dev/null >/dev/null &
621 addtrap "kill $!;"
622 else
623 msgdie 'You have to install weborf or lighttpd first'
624 return 1
f213b6ea 625 fi
c5bcc607
DK
626 local APTARCHIVE="file://$(readlink -f ./aptarchive)"
627 for LIST in $(find rootdir/etc/apt/sources.list.d/ -name 'apt-test-*.list'); do
628 sed -i $LIST -e "s#$APTARCHIVE#http://localhost:8080/#"
629 done
630 return 0
f213b6ea
DK
631}
632
633checkdiff() {
8d876415
DK
634 local DIFFTEXT="$($(which diff) -u $* | sed -e '/^---/ d' -e '/^+++/ d' -e '/^@@/ d')"
635 if [ -n "$DIFFTEXT" ]; then
636 echo
637 echo "$DIFFTEXT"
638 return 1
639 else
640 return 0
641 fi
642}
643
75954ae2
DK
644testfileequal() {
645 local FILE="$1"
646 shift
647 msgtest "Test for correctness of file" "$FILE"
648 if [ -z "$*" ]; then
f213b6ea 649 echo -n "" | checkdiff $FILE - && msgpass || msgfail
75954ae2 650 else
f213b6ea 651 echo "$*" | checkdiff $FILE - && msgpass || msgfail
75954ae2
DK
652 fi
653}
654
8d876415
DK
655testequal() {
656 local COMPAREFILE=$(mktemp)
b720d0bd 657 addtrap "rm $COMPAREFILE;"
8d876415
DK
658 echo "$1" > $COMPAREFILE
659 shift
660 msgtest "Test for equality of" "$*"
f213b6ea 661 $* 2>&1 | checkdiff $COMPAREFILE - && msgpass || msgfail
8d876415
DK
662}
663
685625bd
DK
664testequalor2() {
665 local COMPAREFILE1=$(mktemp)
666 local COMPAREFILE2=$(mktemp)
667 local COMPAREAGAINST=$(mktemp)
b720d0bd 668 addtrap "rm $COMPAREFILE1 $COMPAREFILE2 $COMPAREAGAINST;"
685625bd
DK
669 echo "$1" > $COMPAREFILE1
670 echo "$2" > $COMPAREFILE2
671 shift 2
672 msgtest "Test for equality OR of" "$*"
673 $* 2>&1 1> $COMPAREAGAINST
f213b6ea
DK
674 (checkdiff $COMPAREFILE1 $COMPAREAGAINST 1> /dev/null ||
675 checkdiff $COMPAREFILE2 $COMPAREAGAINST 1> /dev/null) && msgpass ||
676 ( echo "\n${CINFO}Diff against OR 1${CNORMAL}" "$(checkdiff $COMPAREFILE1 $COMPAREAGAINST)" \
677 "\n${CINFO}Diff against OR 2${CNORMAL}" "$(checkdiff $COMPAREFILE2 $COMPAREAGAINST)" &&
685625bd
DK
678 msgfail )
679}
680
8d876415 681testshowvirtual() {
edc0ef10 682 local VIRTUAL="N: Can't select versions from package '$1' as it is purely virtual"
8d876415
DK
683 local PACKAGE="$1"
684 shift
685 while [ -n "$1" ]; do
686 VIRTUAL="${VIRTUAL}
edc0ef10 687N: Can't select versions from package '$1' as it is purely virtual"
8d876415
DK
688 PACKAGE="${PACKAGE} $1"
689 shift
690 done
691 msgtest "Test for virtual packages" "apt-cache show $PACKAGE"
692 VIRTUAL="${VIRTUAL}
4bec02c2 693N: No packages found"
8d876415 694 local COMPAREFILE=$(mktemp)
b720d0bd 695 addtrap "rm $COMPAREFILE;"
8d876415
DK
696 local ARCH=$(dpkg-architecture -qDEB_HOST_ARCH_CPU)
697 eval `apt-config shell ARCH APT::Architecture`
698 echo "$VIRTUAL" | sed -e "s/:$ARCH//" -e 's/:all//' > $COMPAREFILE
e8379ba3 699 aptcache show -q=0 $PACKAGE 2>&1 | checkdiff $COMPAREFILE - && msgpass || msgfail
8d876415
DK
700}
701
702testnopackage() {
703 msgtest "Test for non-existent packages" "apt-cache show $*"
704 local SHOWPKG="$(aptcache show $* 2>&1 | grep '^Package: ')"
705 if [ -n "$SHOWPKG" ]; then
706 echo
707 echo "$SHOWPKG"
708 msgfail
709 return 1
710 fi
711 msgpass
712}
01a6e24c
DK
713
714testdpkginstalled() {
715 msgtest "Test for correctly installed package(s) with" "dpkg -l $*"
87bc1c45
DK
716 local PKGS="$(dpkg -l $* | grep '^i' | wc -l)"
717 if [ "$PKGS" != $# ]; then
01a6e24c
DK
718 echo $PKGS
719 dpkg -l $* | grep '^[a-z]'
720 msgfail
721 return 1
722 fi
723 msgpass
724}
725
5cf733e1
DK
726testdpkgnotinstalled() {
727 msgtest "Test for correctly not-installed package(s) with" "dpkg -l $*"
87bc1c45 728 local PKGS="$(dpkg -l $* 2> /dev/null | grep '^i' | wc -l)"
01a6e24c
DK
729 if [ "$PKGS" != 0 ]; then
730 echo
731 dpkg -l $* | grep '^[a-z]'
732 msgfail
733 return 1
734 fi
735 msgpass
736}
ec7f904e
DK
737
738testmarkedauto() {
739 local COMPAREFILE=$(mktemp)
740 addtrap "rm $COMPAREFILE;"
741 if [ -n "$1" ]; then
742 msgtest 'Test for correctly marked as auto-installed' "$*"
743 while [ -n "$1" ]; do echo "$1"; shift; done | sort > $COMPAREFILE
744 else
745 msgtest 'Test for correctly marked as auto-installed' 'no package'
c98fb5e0 746 echo -n > $COMPAREFILE
ec7f904e
DK
747 fi
748 aptmark showauto 2>&1 | checkdiff $COMPAREFILE - && msgpass || msgfail
749}
89a1aa5d
DK
750
751pause() {
752 echo "STOPPED execution. Press enter to continue"
753 local IGNORE
754 read IGNORE
755}